unit Codolex.Database.Connection.NexusDb;

interface

uses
  Codolex.Database.Connection.Interfaces,
  nxdb;

type
  IDatabaseConnectionNexusDb = interface(IDatabaseConnection)
    ['{2BD64F77-7789-4F43-A2ED-E573C6DC5FCA}']

    function GetConnection: TnxDatabase;

    property Connection: TnxDatabase read GetConnection;
  end;

  TDatabaseConnectionNexusDb = class(TInterfacedObject, IDatabaseConnection, IDatabaseConnectionNexusDb)
  private
    FConnection: TnxDatabase;

    {$REGION 'Getters and Setters'}
    function GetConnection: TnxDatabase;
    function GetConnected: Boolean;
    procedure SetConnected(const Value: Boolean);
    {$ENDREGION}
  public
    constructor Create(const Connection: TnxDatabase);

    procedure StartTransaction;
    procedure Commit;
    procedure Rollback;

    property Connected: Boolean read GetConnected write SetConnected;
    property Connection: TnxDatabase read GetConnection;
  end;


implementation

{ TDatabaseConnectionNexusDb }

constructor TDatabaseConnectionNexusDb.Create(const Connection: TnxDatabase);
begin
  inherited Create;
  FConnection := Connection;
end;

procedure TDatabaseConnectionNexusDb.StartTransaction;
begin
  FConnection.StartTransaction;
end;

procedure TDatabaseConnectionNexusDb.Commit;
begin
  FConnection.Commit
end;

procedure TDatabaseConnectionNexusDb.Rollback;
begin
  FConnection.Rollback;
end;

function TDatabaseConnectionNexusDb.GetConnection: TnxDatabase;
begin
  Result := FConnection;
end;

function TDatabaseConnectionNexusDb.GetConnected: Boolean;
begin
  Result := FConnection.Connected;
end;

procedure TDatabaseConnectionNexusDb.SetConnected(const Value: Boolean);
begin
  FConnection.Connected := Value;
end;

end.
